﻿using System;
using System.Runtime.InteropServices;
using RGB.NET.Devices.Msi.Native;

namespace MsiSDKTest
{
    public class Program
    {
        public static void Main(string[] args)
        {
            try
            {
                Console.WriteLine("Starting ...");
                _MsiSDK.Reload();

                int errorCode = _MsiSDK.Initialize();
                Console.WriteLine("Initialized! (ErrorCode: " + errorCode + ")");

                errorCode = _MsiSDK.GetDeviceInfo(out string[] devices, out int[] ledCounts);
                Console.WriteLine("Got devices: (ErrorCode: " + errorCode + ")");

                for (int i = 0; i < devices.Length; i++)
                    Console.WriteLine(devices[i] + "   - LedCount: " + ledCounts[i]);

                Console.Write("");
                Console.Write("Set Colors");
                for (int i = 0; i < devices.Length; i++)
                {
                    Console.Write($"Device: {devices[i]}");
                    for (int j = 0; j < ledCounts.Length; j++)
                    {
                        _MsiSDK.GetLedInfo(devices[i], j, out string name, out string[] styles);
                        Console.WriteLine($"LED {j}: {name} - {string.Join(", ", styles)}");
                        _MsiSDK.SetLedColor(devices[i], j, 255, 0, 0);
                    }
                }

                Console.Write("");
                Console.Write("Get Colors");
                for (int i = 0; i < devices.Length; i++)
                {
                    Console.Write($"Device: {devices[i]}");
                    for (int j = 0; j < ledCounts.Length; j++)
                    {
                        _MsiSDK.GetLedColor(devices[i], j, out int r, out int g, out int b);
                        Console.WriteLine($"LED {j}: [{r}, {g}, {b}]");
                    }
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine("Exception:");
                Console.WriteLine(ex.Message);
            }
            Console.ReadKey();
        }
    }
}
